=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2007-06-19 13:49:09 +0000
+++ loggerhead/history.py	2007-06-19 13:52:22 +0000
@@ -228,11 +228,10 @@
 
     @with_branch_lock
     def out_of_date(self):
-        revhistory = self._branch.revision_history()
-        if revhistory:
-            return revhistory[-1] != self._last_revid
-        else:
-            return self._last_revid is not None
+        if self._branch.__class__ is not \
+               bzrlib.branch.Branch.open(self._branch.base).__class__:
+            return False
+        return self._branch.last_revision() != self._last_revid
 
     def use_cache(self, cache):
         self._change_cache = cache

=== added file 'loggerhead/tests/test_upgrade.py'
--- loggerhead/tests/test_upgrade.py	1970-01-01 00:00:00 +0000
+++ loggerhead/tests/test_upgrade.py	2007-06-19 13:52:22 +0000
@@ -0,0 +1,31 @@
+from loggerhead.tests.test_simple import BasicTests
+
+import os
+from turbogears import testutil
+import cherrypy
+
+class TestSurviveOverUpgrade(BasicTests):
+
+    def test_upgrade(self):
+        self.createBranch()
+
+        f = open(os.path.join(self.bzrbranch, 'myfilename'), 'w')
+        try:
+            f.write("foo")
+        finally:
+            f.close()
+        self.tree.add('myfilename')
+        msg = 'a very exciting commit message'
+        self.tree.commit(message=msg)
+
+        self.setUpLoggerhead()
+
+        testutil.create_request('/project/branch/changes')
+        assert msg in cherrypy.response.body[0]
+
+        from bzrlib.upgrade import upgrade
+        from bzrlib.bzrdir import format_registry
+        upgrade(self.bzrbranch, format_registry.make_bzrdir('dirstate-tags'))
+
+        testutil.create_request('/project/branch/changes')
+        assert msg in cherrypy.response.body[0]

